"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Compositor = void 0;
var react_1 = __importDefault(require("react"));
var react_scroll_parallax_1 = require("react-scroll-parallax");
var helper_1 = require("./helper");
var Compositor = function (panesPayload, viewportKey, hooks, id) {
    var thisCss = "", thisCssAnimated = "", hasH5P = false, contentMap = {}, contentChildren = {}, impressions = {}, paneIds = [], hasMaxHScreen;
    var contextMode = typeof (id === null || id === void 0 ? void 0 : id.id) === "undefined" ? true : false;
    var keys = contextMode ? ["all"] : [viewportKey];
    panesPayload.forEach(function (p) {
        paneIds.push(p.id);
        keys.forEach(function (key) {
            var _a;
            var hasCodeHook = {};
            var paneHeightRatio = p.field_height_ratio !== "none" ? p.field_height_ratio : false;
            var height = (helper_1.viewportWidth[key] * Number(paneHeightRatio)) / 100;
            var thisPanePayload = PaneCompositor(p, key, hooks);
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasH5P)
                hasH5P = true;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasCodeHook)
                hasCodeHook = thisPanePayload.hasCodeHook;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasMaxHScreen)
                hasMaxHScreen = true;
            else
                hasMaxHScreen = false;
            if (typeof ((_a = thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.impressions) === null || _a === void 0 ? void 0 : _a.payload) === "object")
                impressions[p.id] = __assign(__assign({}, thisPanePayload.impressions.payload), { id: p.id });
            if (typeof (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.css) === "string")
                thisCss = "".concat(thisCss, " ").concat((thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.css) || "");
            if (typeof (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.cssAnimated) === "string")
                thisCssAnimated = "".concat(thisCssAnimated, " ").concat((thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.cssAnimated) || "");
            if (height === 0)
                thisCss = "#".concat(key, "-").concat(p.id, " { height: auto; } ").concat(thisCss, " ");
            else if (height > 0)
                thisCss =
                    "#".concat(key, "-").concat(p.id, " { height: calc(var(--scale) * ").concat(height, " * 1px); } ") +
                        "".concat(thisCss, " ");
            contentChildren["".concat(key, "-").concat(p.id)] = thisPanePayload.children.filter(function (e) {
                return Object.keys(e).length;
            });
            contentMap[p.id] = {
                title: p.title,
                slug: p.field_slug,
                type: !(id === null || id === void 0 ? void 0 : id.id) && id.tractStackId ? "Context" : "Pane",
                parentId: (id === null || id === void 0 ? void 0 : id.id) ? id.id : id.tractStackId,
                hasMaxHScreen: hasMaxHScreen,
                hasCodeHook: hasCodeHook,
            };
        });
    });
    contentMap[id.tractStackId] = {
        title: id.tractStackTitle,
        slug: id.tractStackSlug,
        type: "TractStack",
        parentId: id.tractStackId,
    };
    if ((id === null || id === void 0 ? void 0 : id.id) && (id === null || id === void 0 ? void 0 : id.title) && (id === null || id === void 0 ? void 0 : id.slug)) {
        contentMap[id.id] = {
            title: id.title,
            slug: id.slug,
            type: "StoryFragment",
            parentId: id.tractStackId,
        };
        var storyFragment = {
            paneIds: paneIds,
            css: thisCss,
            cssAnimated: thisCssAnimated,
            hasH5P: hasH5P,
            impressions: impressions,
        };
        return {
            storyFragment: storyFragment,
            contentMap: contentMap,
            contentChildren: contentChildren,
        };
    }
    return {
        contentMap: contentMap,
        contentChildren: contentChildren,
    };
};
exports.Compositor = Compositor;
var PaneCompositor = function (payload, viewportKey, hooks) {
    var _a;
    var hasH5P = false, hasCodeHook = {};
    var optionsPayload = typeof (payload === null || payload === void 0 ? void 0 : payload.field_options) === "string"
        ? ParseOptions(payload.field_options)
        : null;
    var maxHeightScreen = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("max-h-screen")) &&
        optionsPayload["max-h-screen"] === true
        ? true
        : false;
    var paneHeightRatio = payload.field_height_ratio !== "none" ? payload.field_height_ratio : null;
    var paneHeight = (helper_1.viewportWidth[viewportKey] * Number(paneHeightRatio)) / 100;
    var paneHeightOffset = payload.field_height_offset || false;
    var cssAnimatedContainer = (typeof paneHeightOffset === "number" &&
        paneHeightOffset &&
        "#wrapper-".concat(viewportKey, "-").concat(payload.id, " { margin-top: calc(var(--scale) * ").concat(paneHeightOffset.toString(), " * 1px ); }")) ||
        " ";
    var parent = payload.id;
    var compositingPayload = (_a = payload === null || payload === void 0 ? void 0 : payload.relationships) === null || _a === void 0 ? void 0 : _a.field_pane_fragments;
    var compositing = compositingPayload
        .filter(function (e) {
        return typeof (e === null || e === void 0 ? void 0 : e.field_hidden_viewports) === "string" &&
            !e.field_hidden_viewports.includes(viewportKey);
    })
        .sort(function (a, b) { return ((a === null || a === void 0 ? void 0 : a.field_zindex) || 0) - ((b === null || b === void 0 ? void 0 : b.field_zindex) || 0); })
        .map(function (f) {
        var _a, _b;
        switch ((_a = f === null || f === void 0 ? void 0 : f.internal) === null || _a === void 0 ? void 0 : _a.type) {
            case "paragraph__markdown":
                return ParagraphMarkdownCompositor(f, viewportKey, paneHeight, hooks, parent);
            case "paragraph__background_pane":
                var intercept = ParagraphBackgroundPaneCompositor(f, viewportKey, parent);
                if (intercept === null || intercept === void 0 ? void 0 : intercept.hasH5P)
                    hasH5P = true;
                if (intercept === null || intercept === void 0 ? void 0 : intercept.hasCodeHook)
                    hasCodeHook = intercept.hasCodeHook;
                return intercept;
            case "paragraph__background_image":
                return ParagraphBackgroundImageCompositor(f, viewportKey, hooks, parent);
            case "paragraph__background_video":
                return ParagraphBackgroundVideoCompositor(f, viewportKey, parent);
            case "paragraph__svg":
                return ParagraphSvgCompositor(f, viewportKey, parent);
            case "paragraph__background_colour":
                return ParagraphBackgroundColourCompositor(f, viewportKey, payload.id);
            default:
                console.log("No compositor for ".concat((_b = f === null || f === void 0 ? void 0 : f.internal) === null || _b === void 0 ? void 0 : _b.type));
                break;
        }
    });
    var thisChildren = compositing
        .map(function (e) {
        return (e === null || e === void 0 ? void 0 : e.children) || null;
    })
        .filter(function (n) { return n; });
    var thisCss = compositing
        .map(function (e) {
        return (e === null || e === void 0 ? void 0 : e.css) || null;
    })
        .filter(function (n) { return n; });
    var thisCssAnimated = compositing
        .map(function (e) {
        return (e === null || e === void 0 ? void 0 : e.cssAnimated) || null;
    })
        .filter(function (n) { return n; });
    var thisImpressionsPayload = compositing
        .map(function (e) {
        return (e === null || e === void 0 ? void 0 : e.impressions) || null;
    })
        .filter(function (n) { return n; });
    var impressions = thisImpressionsPayload
        .map(function (e) {
        if (e === null || e === void 0 ? void 0 : e.payload)
            return {
                payload: e === null || e === void 0 ? void 0 : e.payload,
            };
        return null;
    })
        .filter(function (n) { return n; });
    var thisCssJoined = thisCss.join(" ");
    var thisCssAnimatedJoined = thisCssAnimated === null || thisCssAnimated === void 0 ? void 0 : thisCssAnimated.map(function (e) {
        return "".concat(e, " ");
    }).join(" ");
    return {
        slug: payload.field_slug,
        children: thisChildren || [],
        css: "".concat(thisCssJoined).replace(/\s\s+/g, ""),
        cssAnimated: "".concat(thisCssAnimatedJoined, " ").concat(cssAnimatedContainer).replace(/\s\s+/g, ""),
        impressions: Object.assign.apply(Object, __spreadArray([{}], impressions, false)),
        hasH5P: hasH5P,
        hasCodeHook: hasCodeHook,
        hasMaxHScreen: maxHeightScreen,
    };
};
var ParagraphMarkdownCompositor = function (payload, viewportKey, paneHeight, hooks, parent) {
    var _a, _b, _c, _d, _e;
    var optionsPayload = ParseOptions(payload === null || payload === void 0 ? void 0 : payload.field_options);
    var hasImpressions = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions) && true;
    var impressions = hasImpressions && ParseImpressions(optionsPayload.impressions, parent);
    var hasModal = payload === null || payload === void 0 ? void 0 : payload.field_modal;
    var thisId = "".concat(viewportKey, "-").concat(payload.id, "-markdown");
    var thisIdModal = "".concat(viewportKey, "-").concat(payload.id, "-modal");
    var zIndex = "z-index: ".concat((payload === null || payload === void 0 ? void 0 : payload.field_zindex) || "100", ";");
    var zIndexModal = hasModal
        ? "z-index: ".concat((payload.field_zindex - 1).toString() || "99", ";")
        : false;
    var hasModalShapeOutside = hasModal && payload.field_text_shape_outside !== "none"
        ? payload.field_text_shape_outside
        : false;
    var isModal = (_a = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.modal) === null || _a === void 0 ? void 0 : _a.hasOwnProperty(viewportKey);
    var thisModalPayload = ((_b = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.modal) === null || _b === void 0 ? void 0 : _b.hasOwnProperty(viewportKey)) &&
        optionsPayload.modal[viewportKey];
    var hasModalShapeOutsidePayload = isModal && hasModalShapeOutside
        ? (0, helper_1.SvgShapeOutsidePayload)(hasModalShapeOutside, viewportKey, thisIdModal, paneHeight, isModal, thisModalPayload)
        : false;
    var hasTextShapeOutsideName = payload.field_text_shape_outside !== "none"
        ? payload.field_text_shape_outside
        : false;
    var hasTextShapeOutsidePayload = hasTextShapeOutsideName && typeof hasTextShapeOutsideName === "string"
        ? (0, helper_1.SvgShapeOutsidePayload)(hasTextShapeOutsideName, viewportKey, thisId, paneHeight, isModal, thisModalPayload)
        : false;
    var hasMaskShape = payload.field_image_mask_shape !== "none"
        ? payload.field_image_mask_shape
        : false;
    var hasMaskPayload = hasMaskShape && hasMaskShape.length
        ? (0, helper_1.SvgImageMaskPayload)(hasMaskShape, "paragraph__background_image", thisId, viewportKey)
        : false;
    var hasModalMaskPayload = isModal && hasMaskShape && (hasMaskShape === null || hasMaskShape === void 0 ? void 0 : hasMaskShape.length)
        ? (0, helper_1.SvgImageMaskPayload)(hasMaskShape, "paragraph__background_modal", thisIdModal, viewportKey)
        : false;
    var cssModalMask = hasModalMaskPayload ? hasModalMaskPayload : "";
    var imageDataArray = (_c = payload === null || payload === void 0 ? void 0 : payload.relationships) === null || _c === void 0 ? void 0 : _c.field_image;
    var hasEffects = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("effects");
    var htmlAst = (_d = payload === null || payload === void 0 ? void 0 : payload.childPaneFragment) === null || _d === void 0 ? void 0 : _d.childMarkdownRemark;
    var astPayload = htmlAst && {
        ast: (_e = htmlAst === null || htmlAst === void 0 ? void 0 : htmlAst.htmlAst) === null || _e === void 0 ? void 0 : _e.children,
        mode: "paragraph__markdown",
        buttonData: optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.buttons,
        imageData: imageDataArray,
        viewportKey: viewportKey,
    };
    var hasClassNames = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("classNames");
    var hasClassNamesAll = hasClassNames
        ? optionsPayload.classNames.hasOwnProperty("all")
        : false;
    var hasClassNamesViewport = hasClassNames
        ? optionsPayload.classNames.hasOwnProperty(viewportKey)
        : false;
    var injectClassNames = hasClassNamesAll
        ? optionsPayload["classNames"]["all"]
        : hasClassNamesViewport
            ? optionsPayload["classNames"][viewportKey]
            : "";
    var hasClassNamesParent = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("classNamesParent");
    var hasClassNamesParentAll = hasClassNamesParent
        ? optionsPayload.classNamesParent.hasOwnProperty("all")
        : false;
    var hasClassNamesParentViewport = hasClassNamesParent
        ? optionsPayload.classNamesParent.hasOwnProperty(viewportKey)
        : false;
    var classNamesParent = hasClassNamesParentAll
        ? optionsPayload["classNamesParent"]["all"]
        : hasClassNamesParentViewport
            ? optionsPayload["classNamesParent"][viewportKey]
            : "";
    var markdownArray = (astPayload && (0, helper_1.HtmlAstToReact)(astPayload, false, injectClassNames, hooks)).filter(function (x) { return x; }) || react_1.default.createElement(react_1.default.Fragment, null);
    var cssMask = hasMaskPayload || "";
    var cssAnimatedPayload = (hasEffects && ParseEffects(optionsPayload.effects, thisId)) || false;
    var cssAnimated = (hasEffects && cssAnimatedPayload) || "";
    var cssAnimatedModal = (cssAnimatedPayload && "#".concat(thisIdModal, " { ").concat(cssAnimatedPayload, " }")) || "";
    var cssCustom = payload.field_css_styles || "";
    var cssCustomModal = payload.field_css_styles_parent || "";
    var cssTextShapeOutside = hasTextShapeOutsidePayload
        ? hasTextShapeOutsidePayload.css
        : "";
    var cssShapeOutsideModal = hasModalShapeOutsidePayload
        ? hasModalShapeOutsidePayload.css
        : "";
    var css = "#".concat(thisId, " { ").concat(zIndex, " ").concat(cssMask, " ").concat(cssCustom, " ").concat(cssTextShapeOutside, " }");
    var cssModal = hasModal
        ? "#".concat(thisIdModal, " { ").concat(zIndexModal, " ").concat(cssCustomModal, " ").concat(cssShapeOutsideModal, " ").concat(cssModalMask, " }")
        : "";
    var working;
    if (typeof classNamesParent === "string")
        working = react_1.default.createElement("div", { className: classNamesParent }, markdownArray);
    else
        classNamesParent.reverse().forEach(function (e) {
            if (typeof working === "undefined")
                working = react_1.default.createElement("div", { className: e }, markdownArray);
            else
                working = react_1.default.createElement("div", { className: e }, working);
        });
    var thisMarkdown = typeof classNamesParent === "string" ? (react_1.default.createElement("div", { className: classNamesParent }, markdownArray)) : (working);
    var jsxMarkdown = hasTextShapeOutsidePayload ? (react_1.default.createElement("div", { id: "".concat(thisId), key: "".concat(thisId), className: "paneFragment paneFragment-".concat(viewportKey, " paneFragmentParagraphOutside") },
        hasTextShapeOutsidePayload.left,
        hasTextShapeOutsidePayload.right,
        thisMarkdown)) : (react_1.default.createElement("div", { id: "".concat(thisId), key: "".concat(thisId), className: "paneFragment paneFragmentParagraph" }, thisMarkdown));
    var jsxModal = hasModalShapeOutsidePayload &&
        typeof hasModalShapeOutsidePayload === "object" ? (react_1.default.createElement("div", { id: "".concat(thisIdModal), key: "".concat(thisIdModal), className: (0, helper_1.classNames)("paneFragment paneFragmentModal", classNamesParent) }, hasModalShapeOutsidePayload === null || hasModalShapeOutsidePayload === void 0 ? void 0 : hasModalShapeOutsidePayload.shape)) : null;
    var thisJsx = !isModal ? [jsxMarkdown] : [jsxModal, jsxMarkdown];
    return {
        children: thisJsx,
        css: "".concat(css, " ").concat(cssModal),
        cssAnimated: "".concat(cssAnimated, " ").concat(cssAnimatedModal),
        impressions: impressions,
    };
};
var ParagraphBackgroundPaneCompositor = function (payload, viewportKey, parent) {
    var hasH5P = false;
    var zIndex = "z-index: ".concat((payload === null || payload === void 0 ? void 0 : payload.field_zindex) || "100", ";");
    var optionsPayload = ParseOptions(payload === null || payload === void 0 ? void 0 : payload.field_options);
    var hasImpressions = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions) && true;
    var impressions = hasImpressions && ParseImpressions(optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions, parent);
    var hasCodeHook = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.codeHook;
    if (hasCodeHook && hasCodeHook.target === "h5p")
        hasH5P = true;
    var thisId = hasCodeHook
        ? "".concat(viewportKey, "-").concat(payload.id, "-hook")
        : "".concat(viewportKey, "-").concat(payload.id, "-pane");
    var shapeName = payload.field_shape !== "none" ? payload.field_shape : null;
    var shape = typeof shapeName === "string" ? (0, helper_1.Svg)(shapeName, viewportKey, thisId) : react_1.default.createElement(react_1.default.Fragment, null);
    var cssCustom = payload.field_css_styles_parent || "";
    var hasEffects = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("effects");
    var hasClassNamesParent = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("classNamesParent");
    var hasClassNamesParentAll = hasClassNamesParent
        ? optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesParent.hasOwnProperty("all")
        : false;
    var hasClassNamesParentViewport = hasClassNamesParent
        ? optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesParent.hasOwnProperty(viewportKey)
        : false;
    var classNamesParent = hasClassNamesParentAll
        ? optionsPayload["classNamesParent"]["all"]
        : hasClassNamesParentViewport
            ? optionsPayload["classNamesParent"][viewportKey]
            : "";
    var cssAnimatedPayload = (hasEffects && ParseEffects(optionsPayload.effects, thisId)) || "";
    var cssAnimated = (hasEffects && cssAnimatedPayload) || "";
    var css = "#".concat(thisId, " { ").concat(zIndex, " ").concat(cssCustom, " } ");
    var thisJsx = hasCodeHook
        ? null
        : [
            react_1.default.createElement("div", { id: "".concat(thisId), key: "".concat(thisId), className: (0, helper_1.classNames)("paneFragment paneFragmentShape", classNamesParent) }, shape),
        ];
    return {
        children: thisJsx,
        css: css,
        cssAnimated: cssAnimated,
        impressions: impressions,
        hasH5P: hasH5P,
        hasCodeHook: hasCodeHook,
    };
};
var ParagraphBackgroundImageCompositor = function (payload, viewportKey, hooks, parent) {
    var _a;
    var thisId = "".concat(viewportKey, "-").concat(payload.id, "-image");
    var getImage = hooks.getImage;
    var GatsbyImage = hooks.GatsbyImage;
    var zIndex = "z-index: ".concat((payload === null || payload === void 0 ? void 0 : payload.field_zindex) || "100", ";");
    var altText = (payload === null || payload === void 0 ? void 0 : payload.field_alt_text) ||
        "We care about A11y and apologize for this missing image description. This should not happen.";
    var backgroundPosition = (payload === null || payload === void 0 ? void 0 : payload.field_background_position) || "center";
    var cssCustom = payload.field_css_styles_parent || "";
    var optionsPayload = ParseOptions(payload === null || payload === void 0 ? void 0 : payload.field_options);
    var parallaxSpeed = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.parallaxSpeed) || false;
    var hasImpressions = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions) && true;
    var maxHeightScreen = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hasOwnProperty("max-h-screen")) &&
        optionsPayload["max-h-screen"] === true
        ? "max-height: 100vh; "
        : "";
    var maxHeightScreenMore = maxHeightScreen !== ""
        ? "#".concat(thisId, " section { max-height:100vh; } ") +
            "#".concat(thisId, " .gatsby-image-wrapper { max-height:100vh; } ")
        : "";
    var impressions = hasImpressions && ParseImpressions(optionsPayload.impressions, parent);
    var hasMaskShape = payload.field_image_mask_shape !== "none"
        ? payload.field_image_mask_shape
        : false;
    var hasMaskPayload = hasMaskShape && hasMaskShape.length
        ? (0, helper_1.SvgImageMaskPayload)(hasMaskShape, "paragraph__background_image", thisId, viewportKey)
        : false;
    var cssMask = hasMaskPayload || "";
    var hasEffects = optionsPayload.hasOwnProperty("effects");
    var cssAnimatedPayload = (hasEffects && ParseEffects(optionsPayload.effects, thisId)) || "";
    var cssAnimated = (hasEffects && cssAnimatedPayload) || "";
    var objectFit = "cover";
    var imageData = (_a = payload === null || payload === void 0 ? void 0 : payload.relationships) === null || _a === void 0 ? void 0 : _a.field_image[0]; // only takes first image
    var imageDataThisViewport = imageData[viewportKey].childImageSharp.gatsbyImageData;
    var image = imageDataThisViewport && getImage(imageDataThisViewport);
    var css = "#".concat(thisId, " { ").concat(maxHeightScreen, " ").concat(zIndex, " ").concat(cssMask, " ").concat(cssCustom, " } ").concat(maxHeightScreenMore, " ") +
        "#".concat(thisId, " { .gatsby-image-wrapper { height:100%; } } ");
    var thisJsx = image ? (react_1.default.createElement("div", { id: "".concat(thisId), key: "".concat(thisId), className: "paneFragment paneFragmentImage" },
        react_1.default.createElement(GatsbyImage, { image: image, alt: altText, style: { backgroundPosition: backgroundPosition }, objectFit: objectFit }))) : (react_1.default.createElement(react_1.default.Fragment, null));
    var thisJsxWrapper = parallaxSpeed ? (react_1.default.createElement("div", { key: thisId },
        react_1.default.createElement(react_scroll_parallax_1.ParallaxProvider, null,
            react_1.default.createElement(react_scroll_parallax_1.Parallax, { speed: parallaxSpeed }, thisJsx)))) : (thisJsx);
    return {
        children: [thisJsxWrapper],
        css: css,
        cssAnimated: cssAnimated,
        impressions: impressions,
    };
};
var ParagraphBackgroundVideoCompositor = function (payload, viewportKey, parent) {
    var thisId = "".concat(viewportKey, "-").concat(payload.id, "-video");
    var zIndex = "z-index: ".concat((payload === null || payload === void 0 ? void 0 : payload.field_zindex) || "100", ";");
    var optionsPayload = ParseOptions(payload === null || payload === void 0 ? void 0 : payload.field_options);
    var hasImpressions = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions) && true;
    var impressions = hasImpressions && ParseImpressions(optionsPayload.impressions, parent);
    var hasMaskShape = payload.field_image_mask_shape !== "none"
        ? payload.field_image_mask_shape
        : null;
    var hasMaskPayload = hasMaskShape && hasMaskShape.length
        ? (0, helper_1.SvgImageMaskPayload)(hasMaskShape, "paragraph__background_image", thisId, viewportKey)
        : false;
    var cssMask = hasMaskPayload || "";
    var hasEffects = optionsPayload.hasOwnProperty("effects");
    var cssAnimatedPayload = (hasEffects && ParseEffects(optionsPayload.effects, thisId)) || "";
    var cssAnimated = (hasEffects && cssAnimatedPayload) || "";
    var url = payload === null || payload === void 0 ? void 0 : payload.field_cdn_url;
    var altText = (payload === null || payload === void 0 ? void 0 : payload.field_alt_text) ||
        "We care about accessibility and apologize for this missing video description. This should not happen.";
    var css = "#".concat(thisId, " { ").concat(zIndex, " ").concat(cssMask, " }");
    var thisJsx = (url && altText && (react_1.default.createElement("div", { id: "".concat(thisId), key: "".concat(thisId), className: "paneFragment paneFragmentVideo" },
        react_1.default.createElement("video", { autoPlay: true, muted: true, loop: true, title: altText },
            react_1.default.createElement("source", { src: url, type: "video/mp4" }))))) || react_1.default.createElement(react_1.default.Fragment, null);
    return {
        children: [thisJsx],
        css: css,
        cssAnimated: cssAnimated,
        impressions: impressions,
    };
};
var ParagraphBackgroundColourCompositor = function (payload, viewportKey, paneId) {
    var bgColour = (typeof payload.field_background_colour === "string" &&
        "background-color: ".concat(payload.field_background_colour, ";")) ||
        "";
    var zIndex = "z-index: 50;";
    var thisId = "".concat(viewportKey, "-").concat(paneId);
    var css = "#".concat(thisId, " { ").concat(bgColour, " ").concat(zIndex, " }");
    return {
        children: [],
        css: css,
    };
};
var ParagraphSvgCompositor = function (payload, viewportKey, parent) {
    var _a, _b, _c, _d;
    var thisId = "".concat(viewportKey, "-").concat(payload.id, "-svg");
    var zIndex = "z-index: ".concat((payload === null || payload === void 0 ? void 0 : payload.field_zindex) || "101", ";");
    var cssCustom = payload.field_css_styles_parent || "";
    var optionsPayload = ParseOptions(payload === null || payload === void 0 ? void 0 : payload.field_options);
    var parallaxSpeed = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.parallaxSpeed) || false;
    var hasMaskShape = payload.field_image_mask_shape !== "none"
        ? payload.field_image_mask_shape
        : false;
    var hasMaskPayload = hasMaskShape && hasMaskShape.length
        ? (0, helper_1.SvgImageMaskPayload)(hasMaskShape, "paragraph__background_image", thisId, viewportKey)
        : false;
    var cssMask = hasMaskPayload || "";
    var hasImpressions = (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions) && true;
    var impressions = hasImpressions && ParseImpressions(optionsPayload.impressions, parent);
    var hasEffects = optionsPayload.hasOwnProperty("effects");
    var cssAnimatedPayload = (hasEffects && ParseEffects(optionsPayload.effects, thisId)) || "";
    var cssAnimated = (hasEffects && cssAnimatedPayload) || "";
    var url = (_c = (_b = (_a = payload === null || payload === void 0 ? void 0 : payload.relationships) === null || _a === void 0 ? void 0 : _a.field_svg_file) === null || _b === void 0 ? void 0 : _b.localFile) === null || _c === void 0 ? void 0 : _c.publicURL;
    var altText = ((_d = payload === null || payload === void 0 ? void 0 : payload.field_svg_file) === null || _d === void 0 ? void 0 : _d.description) ||
        "We care about accessibility and apologize for this missing video description. This should not happen.";
    var css = "#".concat(thisId, " { ").concat(zIndex, " ").concat(cssMask, " ").concat(cssCustom, " }");
    var thisJsx = (url && altText && (react_1.default.createElement("div", { id: "".concat(thisId), key: "".concat(thisId), className: "paneFragment paneFragmentSvg" },
        react_1.default.createElement("img", { src: url, alt: altText })))) || react_1.default.createElement(react_1.default.Fragment, null);
    var thisJsxWrapper = parallaxSpeed ? (react_1.default.createElement("div", { key: thisId },
        react_1.default.createElement(react_scroll_parallax_1.ParallaxProvider, null,
            react_1.default.createElement(react_scroll_parallax_1.Parallax, { speed: parallaxSpeed }, thisJsx)))) : (thisJsx);
    return {
        children: [thisJsxWrapper],
        css: css,
        cssAnimated: cssAnimated,
        impressions: impressions,
    };
};
var ParseOptions = function (payload) {
    var action;
    try {
        action = JSON.parse(payload);
    }
    catch (e) {
        if (e instanceof SyntaxError) {
            console.log("ERROR parsing json options: ", e);
            return null;
        }
    }
    return action;
};
var ParseEffects = function (payload, thisId) {
    var _a, _b, _c;
    var animationIn = (_a = payload === null || payload === void 0 ? void 0 : payload.onscreen) === null || _a === void 0 ? void 0 : _a.function, animationInSpeed = (_b = payload === null || payload === void 0 ? void 0 : payload.onscreen) === null || _b === void 0 ? void 0 : _b.speed, animationInDelay = (_c = payload === null || payload === void 0 ? void 0 : payload.onscreen) === null || _c === void 0 ? void 0 : _c.delay;
    var css = "";
    if (typeof animationIn === "string") {
        css =
            "opacity:0; animation-fill-mode: both; " +
                "animation-name: ".concat(animationIn, "; -webkit-animation-name: ").concat(animationIn, "; ");
        if (typeof animationInSpeed === "number") {
            css = "".concat(css, " animation-duration: ").concat(animationInSpeed, "s; -webkit-animation-duration: ").concat(animationInSpeed, "s; ");
        }
        if (typeof animationInDelay === "number") {
            css = "".concat(css, " animation-delay: ").concat(animationInDelay, "s; ");
        }
        css =
            "div.visible #".concat(thisId, " { ").concat(css, " } ") +
                "div.hidden #".concat(thisId, " { opacity:0; } ");
    }
    return css;
};
var ParseImpressions = function (payload, parent) {
    var thisPayload = [];
    Object.keys(payload).forEach(function (impression) {
        var thisImpression = payload[impression];
        thisPayload.push(thisImpression);
        thisImpression["parentId"] = parent;
    });
    return {
        payload: thisPayload,
    };
};
//# sourceMappingURL=compositor.js.map